﻿ADDUIEVENT("PLAYER_LOGIN", function()
if AddUIDB.ftip ~=  3  then 
--鼠标提示位置
local mode = AddUIDB.ftip
--跟随鼠标
hooksecurefunc("GameTooltip_SetDefaultAnchor", function(tooltip, parent)
if mode == 1 then
	if UnitExists("mouseover")  then
	tooltip:ClearAllPoints()
	tooltip:SetOwner(parent, "ANCHOR_CURSOR_RIGHT", 40, -145)
	else
	tooltip:ClearAllPoints()
	tooltip:SetOwner(parent, "ANCHOR_CURSOR")
	end
elseif mode == 0 then
	tooltip:SetOwner(parent, "ANCHOR_NONE");
	tooltip:SetPoint("BOTTOMRIGHT", MultiBarLeftButton12, "BOTTOMLEFT", 0, 0); --锚点，自己改喜欢的位置
elseif mode == 2 then
	if InCombatLockdown() then 
	tooltip:SetOwner(parent, "ANCHOR_NONE");
	tooltip:SetPoint("BOTTOMRIGHT", MultiBarLeftButton12, "BOTTOMLEFT", 0, 0); --锚点，自己改喜欢的位置
	else
	if UnitExists("mouseover")  then
	tooltip:ClearAllPoints()
	tooltip:SetOwner(parent, "ANCHOR_CURSOR_RIGHT", 40, -145)
	else
	tooltip:ClearAllPoints()
	tooltip:SetOwner(parent, "ANCHOR_CURSOR")
	end
	end
end
end)

--隐藏一些背景
local function style(frame)
    frame:SetScale(1)
	frame.NineSlice:SetCenterColor(0,0,0,.75)
	frame.NineSlice:SetBorderColor(0,0,0,0)

	if (frame.BackdropFrame) then----隐藏大地图鼠标提示边框
		frame.BackdropFrame:Hide()
	end
	if (frame.Border) or (frame.Background) then----隐藏鼠标提示边框及背景
		frame.BorderTop:Hide()
		frame.BorderBottom:Hide()
		frame.BorderLeft:Hide()
		frame.BorderRight:Hide()
		frame.BorderTopLeft:Hide()
		frame.BorderTopRight:Hide()
		frame.BorderBottomLeft:Hide()
		frame.BorderBottomRight:Hide()
		frame.Background:Hide()
		frame.BackdropBorder:Hide()
	end
end
--GameTooltip:HookScript("OnUpdate", style)
style(GameTooltip)

--字体描边
GameTooltipText:SetFont("Fonts\\ARKai_T.ttf",13, "OUTLINE")	--普通字体
GameTooltipTextSmall:SetFont("Fonts\\ARKai_T.ttf", 13, "OUTLINE")	--装备比较字体
GameTooltipHeaderText:SetFont("Fonts\\ARKai_T.ttf", 16, "OUTLINE")	--提示名字

--鼠标提示姓名职业着色
GameTooltip:HookScript("OnTooltipSetUnit", function(GameTooltip)
local _, unit = GameTooltip:GetUnit()
if UnitIsPlayer(unit) then
local _, class = UnitClass(unit)
local color = class and (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class]
if color then
local text = GameTooltipTextLeft1:GetText()
GameTooltipTextLeft1:SetFormattedText("|cff%02x%02x%02x%s|r", color.r * 255, color.g * 255, color.b * 255, text:match("|cff\x\x\x\x\x\x(.+)|r") or text)
end
end
end)

--公会
GameTooltip:HookScript("OnTooltipSetUnit", function(GameTooltip)
local _, unit = GameTooltip:GetUnit()
if UnitIsPlayer(unit) then
local guild, gRank, gRankId = GetGuildInfo(unit)
local hasText = GameTooltipTextLeft2:GetText()
if guild and hasText then
	if (gRank and gRankId) then
		gRank = gRank.."("..gRankId..")"
	end
GameTooltipTextLeft2:SetFormattedText("|cffE41F9B<%s>|r |cffA0A0A0%s|r", guild, gRank or "")
end
end
end)

GameTooltip:HookScript("OnTooltipSetUnit", function(self)
	for i = 3, self:NumLines() do
		local tipLine = _G["GameTooltipTextLeft"..i]
		local tipText = tipLine:GetText()
		if --[[(tipText == FACTION_ALLIANCE) then	--联盟
			tipLine:SetText()
			tipLine:Hide()
		elseif (tipText == FACTION_HORDE) then
			tipLine:SetText()
			tipLine:Hide()
		elseif]] (tipText == PVP) then
			tipLine:SetText(nil)
			tipLine:Hide()
		end
	end
end)
local function formatLines(self)
	local hidden = {}
	local numLines = self:NumLines()

	for i = 2, numLines do
		local tipLine = _G["GameTooltipTextLeft"..i]

		if (tipLine and not tipLine:IsShown()) then
			hidden[i] = tipLine
		end
	end

	for i, line in next, hidden do
		local nextLine = _G["GameTooltipTextLeft"..i+1]

		if (nextLine) then
			local point, relativeTo, relativePoint, x, y = line:GetPoint()
			if x ~= nil then
			nextLine:SetPoint(point, relativeTo, relativePoint, x, y)
			end
		end
	end
end
GameTooltip:HookScript("OnUpdate", formatLines)

--大秘境评分
GameTooltip:SetScript("OnEvent", function(self, event, btn)
	if (btn == "LALT" or btn == "LSHIFT" or btn == "LCTRL")and UnitExists("mouseover") then
		GameTooltip:SetUnit("mouseover")
	end
end)
GameTooltip:RegisterEvent("MODIFIER_STATE_CHANGED")
GameTooltip:HookScript("OnTooltipSetUnit", function(GameTooltip)
local _, unit = GameTooltip:GetUnit()
if (not unit) then return end
local summary = C_PlayerInfo.GetPlayerMythicPlusRatingSummary(unit)			
local score = summary and summary.currentSeasonScore
	if score and score > 0 then
	local color = C_ChallengeMode.GetDungeonScoreRarityColor(score) or HIGHLIGHT_FONT_COLOR
	GameTooltip:AddDoubleLine("史诗评分", score, 0, 0.7, 1, color.r, color.g, color.b)
	end
	local runs = summary and summary.runs
	if runs and (IsAltKeyDown() or IsShiftKeyDown() or IsControlKeyDown()) then
		GameTooltip:AddLine("     ")
		GameTooltip:AddDoubleLine("副本", "评分层数", 1, 1, 1, 1, 1, 1)
	for i, info in pairs(runs) do
	local map = C_ChallengeMode.GetMapUIInfo(info.challengeModeID)
	local colort = C_ChallengeMode.GetDungeonScoreRarityColor(info.mapScore*8)
	GameTooltip:AddDoubleLine(map, info.mapScore.."("..info.bestRunLevel..")", 1, 1, 1, colort.r, colort.g, colort.b)
	end
	end
end)

--鼠标提示血条样式
GameTooltipStatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-TargetingFrame-BarFill")
GameTooltipStatusBar:SetHeight(3)
GameTooltipStatusBar:SetHeight(3)
GameTooltipStatusBar:ClearAllPoints()
GameTooltipStatusBar:SetPoint("BOTTOMLEFT", GameTooltipStatusBar:GetParent(), "TOPLEFT", 5, -4)	--血条左边
GameTooltipStatusBar:SetPoint("BOTTOMRIGHT", GameTooltipStatusBar:GetParent(), "TOPRIGHT", -5, -4)	--血条右边
--鼠标提示血条职业着色
GameTooltip:HookScript("OnTooltipSetUnit", function(GameTooltip)
local _, unit = GameTooltip:GetUnit()
if UnitIsPlayer(unit) then
local _, class = UnitClass(unit)
local color = class and (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class]
GameTooltipStatusBar:SetStatusBarColor(color.r,color.g,color.b)
GameTooltipStatusBar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar") --血条材质，自己改喜欢的
end
end)


--鼠标提示目标染色function
--func GetHexColor
local function GetHexColor(color)
  return ("%.2x%.2x%.2x"):format(color.r*255, color.g*255, color.b*255)
end

local classColors, reactionColors = {}, {}

for class, color in pairs(RAID_CLASS_COLORS) do
  classColors[class] = GetHexColor(RAID_CLASS_COLORS[class])
end

for i = 1, #FACTION_BAR_COLORS do
  reactionColors[i] = GetHexColor(FACTION_BAR_COLORS[i])
end

local function GetTarget(unit)
  if UnitIsUnit(unit, "player") then
    return ("|cffff0000%s|r"):format(">你<")
  elseif UnitIsPlayer(unit, "player")then
    return ("|cff%s%s|r"):format(classColors[select(2, UnitClass(unit))], UnitName(unit))
  elseif UnitReaction(unit, "player") then
    return ("|cff%s%s|r"):format(reactionColors[UnitReaction(unit, "player")], UnitName(unit))
  else
    return ("|cffffffff%s|r"):format(UnitName(unit))
  end
end

-- 鼠标提示目标职业颜色
local GameTooltip = GameTooltip
GameTooltip:HookScript("OnTooltipSetUnit", function(self)
	local _, unit = self:GetUnit()
	if (not unit) then return end

	if (UnitIsUnit("player", unit .. "target")) then----目标职业颜色
		self:AddDoubleLine("目标: "..GetTarget(unit.."target") or "Unknown")----self:AddLine("< YOU >", 0.5, 1)
	elseif (UnitExists(unit .. "target")) then
		self:AddDoubleLine("目标: "..GetTarget(unit.."target") or "Unknown")----self:AddLine(UnitName(unit .. "target"), 0.5, 1)
	end
end)

--buff来源
local function SetCaster(self, unit, index, filter)
local name, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable = UnitBuff(unit, index, filter)
if unitCaster then
local uname, urealm = UnitName(unitCaster)
local _, uclass = UnitClass(unitCaster)
local cr,cb,cg = GetClassColor(uclass)
if urealm then uname = uname .. '-' .. urealm end
self:AddDoubleLine("施法者:",uname, nil, nil, nil,cr,cb,cg)
self:Show()
end
end
hooksecurefunc(GameTooltip, 'SetUnitAura', SetCaster)
hooksecurefunc(GameTooltip, 'SetUnitBuff', function(self, unit, index, filter)
filter = filter and ('HELPFUL ' .. filter) or 'HELPFUL'
SetCaster(self, unit, index, filter)
end)
hooksecurefunc(GameTooltip, 'SetUnitDebuff', function(self, unit, index, filter)
filter = filter and ('HARMFUL ' .. filter) or 'HARMFUL'
SetCaster(self, unit, index, filter)
end)

end
end)